#include<stdio.h>

int leap, Y;
int dny[366];
int prvniD, mesice[12], svatky[12];
char S[11], R[1001];

int velikonocniPondeli(int y) {  
  int golden, solar, lunar, p;
  golden = (y % 19) + 1;
  solar = (y - 1600) / 100 - (y - 1600) / 400;
  lunar = (((y - 1400) / 100) * 8) / 25;
  p = (3003 - (11 * golden) + solar - lunar) % 30;
  if (p == 29  || (p == 28 && golden > 11)) p--;
  int reseni = mesice[2] + 20 + p + 1;
  while ((reseni + prvniD) % 7 != 6)
    reseni++;
  reseni++;
  return reseni;  
}

int prvniDen(int rok) {
  leap = (rok % 400 == 0 || (rok % 4 == 0 && rok % 100 != 0))? 1 : 0;

  int mod[] = {0,6,4,2};
  int cm = mod[((int)(rok / 100) - 15) % 4];
  rok %= 100;
  return (rok + (int)(rok / 4) + cm + (leap ? 6 : 0)) % 7;
}


int pocetJizd(int rok) {
  leap = (rok % 400 == 0 || (rok % 4 == 0 && rok % 100 != 0))? 1 : 0;
  mesice[0] = 0;
  mesice[1] = mesice[0]+31;
  mesice[2] = mesice[1] + (leap ? 29 : 28);
  mesice[3] = mesice[2] + 31;
  mesice[4] = mesice[3] + 30;
  mesice[5] = mesice[4] + 31;
  mesice[6] = mesice[5] + 30;
  mesice[7] = mesice[6] + 31;
  mesice[8] = mesice[7] + 31; 
  mesice[9] = mesice[8] + 30;
  mesice[10] = mesice[9] + 31;
  mesice[11] = mesice[10] + 30;

  prvniD = prvniDen(rok);

  svatky[0] = 0;
  svatky[1] = velikonocniPondeli(rok);
  svatky[2] = mesice[4];
  svatky[3] = mesice[4] + 7;
  svatky[4] = mesice[6] + 4;
  svatky[5] = mesice[6] + 5;
  svatky[6] = mesice[8] + 27;
  svatky[7] = mesice[9] + 27;
  svatky[8] = mesice[10] + 16;
  svatky[9] = mesice[11] + 23;
  svatky[10] = mesice[11] + 24;
  svatky[11] = mesice[11] + 25;

  int i, k;
int ctc=0;
  printf("R=%s  ", R);
  for (i = 0; R[i] != '\0'; i++) {
    if (R[i] >= 48 && R[i] <= 57) {
      int den = R[i] - 48 - 1; /* pon = 0 */ printf("den=%d   ", den);
      for (k = 0; k < (leap ? 366 : 365);k++) {
        dny[k] = (((prvniD + k) % 7) == den) || dny[k];
        if (dny[k]) ctc++;
      }
    }
    else if (R[i] == 't') {
      for (i = 0; i < 12; i++)
        dny[svatky[i]] = 1;
      for (k = 0; k < (leap ? 366 : 365);k++) {
        dny[k] = (((prvniD + k) % 7) == 6) || dny[k];
      }
    }
    else if (R[i] == 'w') {
      k = 0;
      for (i = 0; i < (leap ? 366 : 365); i++) {
        if (k < 12) {
          if (i == svatky[k])
            k++;
          else
            dny[i] = ((prvniD + i) % 7 < 5) || dny[i];
        }
        dny[i] = ((prvniD + i) % 7 < 5) || dny[i];
      }
    }
    else if (R[i] == 'a') {
      for (i = 0; i < 12; i++)
        dny[svatky[i]+1] = ((dny[svatky[i]+1] + prvniD) % 7 < 5) || dny[svatky[i]+1];
      for (k = 0; k < (leap ? 366 : 365);k++) {
        dny[k] = (((prvniD + k) % 7) == 0) || dny[k];
      }
    }
  }

  int zn = 0;
  while (S[zn] != '\0') {
    int d1, m1, d2, m2;
    d1 = S[zn] - 48; zn++;
    if (S[zn] >= 48 && S[zn] <= 57) { d1 = 10 * d1 + S[zn] - 48; zn++; }
    zn++;
    m1 = S[zn] - 48; zn++;
    if (S[zn] >= 48 && S[zn] <= 57) { m1 = 10 * m1 + S[zn] - 48; zn++; }      
    zn++;
    if (S[zn] == '-') { zn++;
      d2= S[zn] - 48; zn++;
      if (S[zn] >= 48 && S[zn] <= 57) { d2 = 10 * d2 + S[zn] - 48; zn++; }
      zn++;
      m2 = S[zn] - 48; zn++;
      if (S[zn] >= 48 && S[zn] <= 57) { m2 = 10 * m2 + S[zn] - 48; zn++; }      
      zn++;zn++;

      for (k = mesice[m1 - 1] + d1 - 1; k <= mesice[m2 - 1] + d2 - 1; k++)
        if (dny[k] == 1)        
          dny[k] = 2;
    }
    else { zn++;
       if (dny[mesice[m1 - 1] + d1 - 1] == 1) dny[mesice[m1 - 1] + d1 - 1] = 2;
    }

    printf("%d.%d.-%d.%d.  ", d1, m1, d2, m2);
  }
  int vysledek = 0;
  for (i = 0; i < (leap ? 366 : 365); i++) {
    if (dny[i] == 2) vysledek++;
  }
  return vysledek;

}


int main() {
  while (scanf("%s %s %d", R, S, &Y) != EOF) {
    printf("%d\n", pocetJizd(Y));
  }
  return 0;
}


